'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reduxObservable = reduxObservable;

var _Subject = require('rxjs/Subject');

var _from = require('rxjs/observable/from');

var _ActionsObservable = require('./ActionsObservable');

function reduxObservable(processor) {
  var actions = new _Subject.Subject();
  var actionsObs = new _ActionsObservable.ActionsObservable(actions);

  var middleware = function middleware(store) {
    return function (next) {
      if (processor) {
        processor(actionsObs, store).subscribe(store.dispatch);
      }
      return function (action) {
        if (typeof action === 'function') {
          var obs = (0, _from.from)(action(actionsObs, store));
          var sub = obs.subscribe(store.dispatch);
          return sub;
        } else {
          var result = next(action);
          actions.next(action);
          return result;
        }
      };
    };
  };

  return middleware;
}